package interface_graphique;

import common.FullDuplexMsgWorker;

/**
 * Une tâche envoyée au Thread de Swing.
 * Crée la fenêtre d'affichage et la rend visible
 * 
 * @author Éric Lallet.
 */
public class CreationInterfaceGraphique implements Runnable {
	/**
	 * Jframe qui contientra l'interface graphique.
	 */
	private InterfaceGraphique fenetre;
	/**
	 * nombre de lignes de la fenètre de tchat.
	 */
	private final int nbLignes; 
	/**
	 * Pseudonyme de l'utilisateur.
	 */
	private String pseudo;
	/**
	 * le worker qui réalisera les échanges TCP avec le serveur.
	 */
	private FullDuplexMsgWorker worker;
	
	/**
	 * 
	 * @param nbLignes 
	 *                nombre de lignes de la fenètre de tchat.
	 * @param pseudo
	 *              pseudonyme de l'utilisateur.
	 * @param worker
	 *              le worker qui réalisera les échanges TCP avec le serveur.
	 */
	public CreationInterfaceGraphique(final int nbLignes, final String pseudo, final FullDuplexMsgWorker worker) {
		this.nbLignes = nbLignes;
		this.pseudo = pseudo;
		this.worker = worker;
	}
	

	@Override
	public void run() {
		this.fenetre = new InterfaceGraphique(this.nbLignes, pseudo, worker);
		this.fenetre.setVisible(true);
	}
	
	/**
	 * 
	 * @return la JFrame qui contient l'interfacegraphique.
	 */
	public InterfaceGraphique getFenetre() {
		return this.fenetre;
	}

}
