package trivial;


import static common.Log.COMM;
import static common.Log.LOGGER_NAME_COMM;
import static common.Log.LOG_ON;

import common.Log;
import org.apache.log4j.Level;

import java.io.IOException;

/**
 * 
 * @author Éric Lallet.
 *
 */
public final class AppliServer {
	/**
	 * max number of expected arguments of main method.
	 */
	private static final int NBARGS = 1;
	/**
	 * position in argv[] of the port number.
	 */
	private static  final int MONPORTARG = 0;	
	
	/**
	 * URL of the web service.
	 */
	public static final String TRIVIALHTTPURL =  "https://opentdb.com/api.php?amount=1&type=multiple&encode=url3986";
	
	/**
	 * 
	 */
	private AppliServer() {
		
	}
	
	
	

	/**
	 * 
	 * @param argv
	 * 	          argv[0] server port number.
	 */
	public static void main(final String[] argv) {
			
		if ((argv.length != NBARGS)) {
			System.out.println("usage: java MainSelectorMsgServer <mon port>");
				return;
		}
		
		Log.configureALogger(LOGGER_NAME_COMM, Level.TRACE); // tout est logué pour la comm
		if (LOG_ON && COMM.isEnabledFor(Level.TRACE)) {
			COMM.trace("Starting trivial server");
		}
		try {
			new TrivialServer(Integer.parseInt(argv[MONPORTARG]), TRIVIALHTTPURL);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
