package trivial;


import static common.Log.TEST;

import java.io.IOException;

import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;

import java.util.HashMap;
import java.util.Map;



import common.FullDuplexMsgWorker;
import json.TrivialJson;
import json.TrivialQuestion;

/**
 * 
 * @author Éric Lallet.
 *
 */
public class TrivialServer {
	/**
	 * number of seconds before sending the correct answer to the players.
	 */
	private static final int  WAITINGTIMER = 30; // seconds
	/**
	 * number of seconds before sending new question after sending the  answer of the precedent one.
	 */
	private static final int PENDINGTIMER = 30; // seconds
	/**
	 * number of seconds before stopping server if no connection happens.
	 */
	private static final int SLEEPINGTIMER = 3600; // seconds (1 hour)  
	/**
	 * number of milliseconds in one second.
	 */
	private static final int THOUSAND = 1000;
	
	/**
	 * server port number. 
	 */
	private int port;
	
	/**
	 * URL of the trivial json service.
	 */
	private String trivialHttpUrl;
	
	/**
	 * Association between the channel and the worker.
	 */
	private	Map<SelectionKey, FullDuplexMsgWorker> theClients;
	
	/**
	 * 
	 */
	private Selector selector;
	
	
	
	/**
	 * state of this server.
	 */
	private TrivialServerState serverState = TrivialServerState.SLEEPING;  
	
	
	/**
	 * TrivialQuestion with no question.
	 */
	private  final TrivialQuestion voidTrivialQuestion = new TrivialJson().getTrivialQuestion();
	
	/**
	 * TrivialQuestion to be sent to the clients.
	 */
	private TrivialQuestion trivialQuestion;
	
	/**
	 * players answer list + correct answer.
	 */
	private  AnswersList answersList = null;
	
	
	/**
	 * the beginning time of the sleeping state.
	 */
	private long sleepingTime;
	/**
	 * the beginning time of the waiting state.
	 */
	private  long waitingTime;
	/**
	 * the beginning time of the pending state.
	 */
	private long pendingTime;
	
	

	
	/**
	 * 
	 * @param port
	 *            server port number.
	 * @param trivialHttpUrl
	 *            URL of the trivial json service.
	 * @throws IOException 
	 *            the exception thrown in case of IO problem.
	 */
	public TrivialServer(final int port, final String trivialHttpUrl) throws IOException {
		this.port = port;
		this.trivialHttpUrl = trivialHttpUrl;
		this.play();
	}
	
	
	

	
	/**
	 * create a new ServerSocketChannel.
	 * @return
	 *        the new ServerSocketChannel
	 * @throws IOException
	 *         the exception thrown in case of IO problem.
	 */
	private ServerSocketChannel openListenChannel() throws IOException {
		ServerSocketChannel listenChannel = null;

		// TODO Question 3.3.1

		return listenChannel;

	}

	/**
	 * accept a new client.
	 * @param listenChannel
	 *                listenChannel for the accept.
	 * @throws IOException
	 *                    the exception thrown in case of IO problem.
	 */
	private void acceptNewPlayer(final ServerSocketChannel listenChannel) throws IOException {
			// TODO Question 3.3.2 à faire après Question 3.3.1
	}

	
	/**
	 * Ask a new trivial card to the http server, and send the question to all connected players.
	 * @throws IOException
	 *                    the exception thrown in case of IO problem.
	 */
	private void sendNewQuestion() throws IOException {
		// TODO Question 3.3.3 à faire après la question 3.3.2  
	}


	/**
	 * receive an answer from player. Add this answer in the server annsersList.
	 * @param key
	 *           key bind to client channel in theClients Map.
	 * @throws IOException
	 *           the exception thrown in case of IO problem.
	 */
	private void recieveAnswerFromPlayer(final SelectionKey key) throws IOException {
		// TODO Question 3.3.4 début à faire après les questions 3.3.3 
	}

	/**
	 * send to all players the players answer list with the correct answer.
	 * @throws IOException
	 *                   the exception thrown in case of IO problem.
	 */
	private void sendCorrectAnswer() throws IOException {
		// TODO Question 3.3.4 suite à faire après la question 3.3.4 début  
		
	}




	/**
	 * change  the server state and send data to the client if needed.
	 * @return
	 *        timer of the next select().
	 * @throws IOException
	 *          the exception thrown in case of IO problem.
	 */
	private long changeStateAndSendData() throws IOException {
		long selectTimer = 0;

		// TODO Question 3.3.5 à faire après la question 3.3.4
		
		return selectTimer;
	}



	/**
	 * loop of the server.
	 * @throws IOException
	 *         the exception thrown in case of IO problem.
	 */
	private void play() throws IOException {
		ServerSocketChannel listenChannel;

		// TODO Question 3.6 à faire après la question 3.5

		

	}
	
	/****************************************** 
	**         methodes for testing          **                 
	**           DO NOT MODIFY               **
	*******************************************/	
	
	/**
	 * true if constructed for testing.
	 */
	private boolean testServer = false;
	
	/**
	 * don't use it. Only for tests.
	 */
	private ServerSocketChannel testListenChannel;
	

	
	/**
	 * Special constructor for unit tests.
	 * @param port
	 *            server port number.
	 * @param trivialHttpUrl
	 *             URL of the trivial json service.
	 * @param testId
	 *             id of the test.
	 * @throws IOException 
	 *             the exception thrown in case of IO problem.
	 */
	public TrivialServer(final int port, final String trivialHttpUrl, final TestId testId) throws IOException {
		this.port = port;
		this.trivialHttpUrl = trivialHttpUrl;
		this.testServer = true;
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("TrivialServer instance created for " + testId);
		}
		
	}
	
	/**
	 * public method for unit test.
	 * @param testId
	 *              testId of the unit test.
	 * @throws IOException 
	 *              the exception thrown in case of IO problem.
	 */
	public void playTest(final TestId testId) throws IOException {
		if (!testServer) {
			return;
		}
		switch (testId) {
		case OPENLISTENCHANNEL:
			testListenChannel = this.openListenChannel();
			theClients = new HashMap<SelectionKey, FullDuplexMsgWorker>();
			serverState =  TrivialServerState.SLEEPING;
			selector = Selector.open();
			
			break;
		case ACCEPTNEWPLAYER:
			this.acceptNewPlayer(testListenChannel);
			break;
			
		case ACCEPTNEWPLAYER2:
			for (SelectionKey key: theClients.keySet()) {
				theClients.get(key).sendMsg(MessType.TRIVIALQUESTIONTYPE, voidTrivialQuestion);
			}
			break;
		case SENDNEWQUESTION:
			//this.acceptNewPlayer(testListenChannel);
			this.sendNewQuestion();
			break;
		case SENDNEWQUESTION2:
			for (SelectionKey key: theClients.keySet()) {
				theClients.get(key).sendMsg(MessType.ANSWERSLISTTYPE, answersList);
			}
			break;
			
		case RECEIVEANSWERFROMLPLAYER:
			for (SelectionKey key: theClients.keySet()) {
				this.recieveAnswerFromPlayer(key);
			
			}
			break;
			
		case RECEIVEANSWERFROMLPLAYER2:
			// send back the answers
			for (SelectionKey key: theClients.keySet()) {
				theClients.get(key).sendMsg(MessType.ANSWERSLISTTYPE, answersList);
			}
			
			break;
			
		case SENDCORRECTANSWER:
			this.sendCorrectAnswer();
			break;
			
		case CHANGESTATE1:
			this.changeStateAndSendData();
			break;
		case CHANGESTATE2:
			this.waitingTime -= WAITINGTIMER * THOUSAND;
			this.changeStateAndSendData();
			break;
		case CHANGESTATE3:
			this.pendingTime -= PENDINGTIMER * THOUSAND;
			this.changeStateAndSendData();
			break;
		case CHANGESTATE4:
		case CHANGESTATE5:
		    // using closed connection: should reset theClients Map 
		    for (SelectionKey key: theClients.keySet()) {
			this.recieveAnswerFromPlayer(key);
			
		    }
		    changeStateAndSendData(); // 0 client -> back to sleeping state
		    break;
		default:
			break;
	
		
		}	
	}
	
}
