package https;

import static common.Log.LOGGER_NAME_TEST;
import static common.Log.LOG_ON;
import static common.Log.TEST;
import static org.junit.Assert.assertTrue;

import java.nio.ByteBuffer;

import org.apache.log4j.Level;
import org.junit.Ignore;
import org.junit.Test;

import common.Log;


public class TestConnect {
	
	@Ignore
	@Test
	public void testConnect() throws Exception {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		ByteBuffer buff = ByteBuffer.allocate(1024);

		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("starting tests of https connexion");
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testConnect: SSL negociation");
		}
		HttpsProtocol https = new HttpsProtocol();
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testConnect: connexion");
		}
		https.connectTo("https://opentdb.com/api.php?amount=1&type=multiple&encode=url3986");
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testconnect: check status");
		}
		assertTrue("Status Connected", https.getStatus() == Status.Connected);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testConnect: check channel");
		}
		assertTrue("channel created", https.getHttpChan() != null);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testConnect: trying to use connexion");
		}
		int readSize = https.getHttpChan().read(buff);
		assertTrue("reading enable", readSize != 0);
		

		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("end of tests of https connexion");
		}
		
	}

}
