package trivial;

import static common.Log.LOGGER_NAME_TEST;
import static common.Log.LOG_ON;
import static common.Log.TEST;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.channels.SocketChannel;

import org.apache.log4j.Level;
import org.junit.Ignore;
import org.junit.Test;

import common.FullDuplexMsgWorker;
import common.Log;
import common.ReadMessageStatus;
import json.TrivialJson;
import json.TrivialQuestion;

public class TestAcceptNewPlayer {
	static public final int PORT = 5010;
	static public final String HOST = "localhost";
	static public final String NICK = "Pseudo";
	private  final TrivialQuestion noneTrivialQuestion = new TrivialJson().getTrivialQuestion();
	
	@Ignore
	@Test
	public void testAcceptNewPlayer() throws IOException {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("starting " + TestId.ACCEPTNEWPLAYER);
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: starting server");
		}
		// create new server
		TrivialServer trivialServer = new TrivialServer(PORT, AppliServer.TRIVIALHTTPURL, TestId.ACCEPTNEWPLAYER);
		
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: creating ServerSocketChannel");
		}
		// server: open the listen channel
		trivialServer.playTest(TestId.OPENLISTENCHANNEL);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: connecting to server");
		}
		// connecting to the server
		SocketChannel  rwChan = SocketChannel.open(new InetSocketAddress(InetAddress.getByName(HOST),PORT ));
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept....");
		}
		// server: accept new player
		trivialServer.playTest(TestId.ACCEPTNEWPLAYER);
	 
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: server send data");
		}
		// server: send data for testing connexion
		trivialServer.playTest(TestId.ACCEPTNEWPLAYER2);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: receiving data");
		}
		// receiving data
		FullDuplexMsgWorker worker = new FullDuplexMsgWorker(rwChan);
		ReadMessageStatus status = ReadMessageStatus.ReadUnstarted;
		
		
		while ((status != ReadMessageStatus.ChannelClosed) && (status != ReadMessageStatus.ReadDataCompleted)) { 
			status = worker.readMessage();
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: data completed");
		}
		assertTrue("Testting data completed" , status == ReadMessageStatus.ReadDataCompleted);
		
		TrivialQuestion trivialQuestion = (TrivialQuestion) worker.getData();
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing accept: checking data");
		}
		assertEquals("testing data", trivialQuestion, noneTrivialQuestion);
		
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("end of " + TestId.ACCEPTNEWPLAYER);
		}
		
		
	}
	

}
