package trivial;

import static common.Log.LOGGER_NAME_TEST;
import static common.Log.LOG_ON;
import static common.Log.TEST;
import static org.junit.Assert.assertTrue;

import java.io.IOException;
import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.nio.channels.SocketChannel;

import org.apache.log4j.Level;
import org.junit.Ignore;
import org.junit.Test;

import common.FullDuplexMsgWorker;
import common.Log;
import common.ReadMessageStatus;
import json.TrivialQuestion;

public class TestSendNewQuestion {
	static public final int PORT = 5010;
	static public final String HOST = "localhost";
	static public final String NICK = "Pseudo";
	
	
	@Ignore
	@Test
	public void testSendNewQuestion() throws IOException {
		Log.configureALogger(LOGGER_NAME_TEST, Level.TRACE);
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("starting " + TestId.SENDNEWQUESTION);
		}
		
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: creating server");
		}	
		// creating new server
		TrivialServer trivialServer = new TrivialServer(PORT, AppliServer.TRIVIALHTTPURL, TestId.SENDNEWQUESTION);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: creatin ServerSocketChannel");
		}
		// server: open listen channel
		trivialServer.playTest(TestId.OPENLISTENCHANNEL);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: connecting to server");
		}
		// connexion to this server
		SocketChannel  rwChan = SocketChannel.open(new InetSocketAddress(InetAddress.getByName(HOST),PORT ));
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: server accept");
		}
		// server accept new player
		trivialServer.playTest(TestId.ACCEPTNEWPLAYER);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion");
		}
		// server send new question
		trivialServer.playTest(TestId.SENDNEWQUESTION);
	 
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: receiving the question");
		}
		// reveining and testing data
		FullDuplexMsgWorker worker = new FullDuplexMsgWorker(rwChan);
		ReadMessageStatus status = ReadMessageStatus.ReadUnstarted;
		
		
		while ((status != ReadMessageStatus.ChannelClosed) && (status != ReadMessageStatus.ReadDataCompleted)) { 
			status = worker.readMessage();
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: checking data ");
		}
		assertTrue("Testing data completed" , status == ReadMessageStatus.ReadDataCompleted);
		
		TrivialQuestion trivialQuestion = (TrivialQuestion) worker.getData();
		
		
		assertTrue("Testting data not null" , trivialQuestion != null);
		
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: testing if new answerList has been created");
		}
		// server: send answer list
		trivialServer.playTest(TestId.SENDNEWQUESTION2);
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: receiving answersList ");
		}
		// receiving and testing answer list (must be empty)
		status = ReadMessageStatus.ReadUnstarted;
		
		while ((status != ReadMessageStatus.ChannelClosed) && (status != ReadMessageStatus.ReadDataCompleted)) { 
			status = worker.readMessage();
		}
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: checking data ");
		}
		assertTrue("Testting data completed" , status == ReadMessageStatus.ReadDataCompleted);
		
		
		AnswersList answersList = (AnswersList) worker.getData();
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: answerList should be empty");
		}
		assertTrue("Testing answerList is empty", answersList.getNbAnswers() == 0);
		
		
		
		if (LOG_ON && TEST.isEnabledFor(Level.TRACE)) {
			TEST.trace("testing SendNewQuestion: correct answer should be set");
		}
		assertTrue("Testing answerList is empty", answersList.getCorrectAnswer() != -1);

	
		if (LOG_ON && TEST.isInfoEnabled()) {
			TEST.info("end of " + TestId.SENDNEWQUESTION);
		}
	}

	

}
